2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see https://www.gnu.org/licenses/ .
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19 echo "Error: The notmuch test suite requires a bash version >= 4.0"
20 echo "due to use of associative arrays within the test suite."
21 echo "Please try again with a newer bash (or help us fix the"
22 echo "test suite to be more portable). Thanks."
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34 echo >&2 'You do not seem to have built notmuch yet.'
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
46 # do not redirect again
48 *' --tee '*|*' --va'*)
50 BASE=test-results/$this_test
51 (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52 echo $? > $BASE.exit) | tee $BASE.out
53 test "$(cat $BASE.exit)" = 0
58 # Save STDOUT to fd 6 and STDERR to fd 7.
60 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
62 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
64 # Keep the original TERM for say_color and test_emacs
67 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
68 # Otherwise use whatever TERM is currently used so that
69 # users' actual TERM environments are being used in tests.
77 # For repeatability, reset the environment to known value.
83 export LANG LC_ALL PAGER TERM TZ
84 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
85 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
86 ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
87 echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
90 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
91 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
92 TEST_GDB=${TEST_GDB:-gdb}
93 TEST_CC=${TEST_CC:-cc}
94 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
96 # Protect ourselves from common misconfiguration to export
97 # CDPATH into the environment
103 unset ALTERNATE_EDITOR
108 [ -d ${GNUPGHOME} ] && return
109 _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
110 at_exit_function _gnupg_exit
111 mkdir -m 0700 "$GNUPGHOME"
112 gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
113 test_debug "cat $GNUPGHOME/import.log"
114 if (gpg --quick-random --version >/dev/null 2>&1) ; then
115 echo quick-random >> "$GNUPGHOME"/gpg.conf
116 elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
117 echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
119 echo no-emit-version >> "$GNUPGHOME"/gpg.conf
122 # Each test should start with something like this, after copyright notices:
124 # test_description='Description of this test...
125 # This test checks if command xyzzy does the right thing...
127 # . ./test-lib.sh || exit 1
129 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
130 TERM=$ORIGINAL_TERM &&
133 tput bold >/dev/null 2>&1 &&
134 tput setaf 1 >/dev/null 2>&1 &&
135 tput sgr0 >/dev/null 2>&1
139 while test "$#" -ne 0
145 immediate=t; shift ;;
153 with_dashes=t; shift ;;
160 valgrind=t; verbose=t; shift ;;
162 shift ;; # was handled already
164 echo "error: unknown test option '$1'" >&2; exit 1 ;;
168 if test -n "$debug"; then
170 printf " %-4s" "[$((test_count - 1))]"
178 if test -n "$color"; then
184 error) tput bold; tput setaf 1;; # bold red
185 skip) tput bold; tput setaf 2;; # bold green
186 pass) tput setaf 2;; # green
187 info) tput setaf 3;; # brown
188 *) test -n "$quiet" && return;;
199 test -z "$1" && test -n "$quiet" && return
208 say_color error "error: $*\n"
217 test "${test_description}" != "" ||
218 error "Test script did not set test_description."
220 if test "$help" = "t"
222 echo "Tests ${test_description}"
226 test_description_printed=
227 print_test_description ()
229 test -z "$test_description_printed" || return 0
231 echo $this_test: "Testing ${test_description}"
232 test_description_printed=1
234 if [ -z "$NOTMUCH_TEST_QUIET" ]
236 print_test_description
245 declare -a _exit_functions=()
247 at_exit_function () {
248 _exit_functions=($1 ${_exit_functions[@]/$1})
251 rm_exit_function () {
252 _exit_functions=(${_exit_functions[@]/$1})
259 for _fn in ${_exit_functions[@]}; do $_fn; done
260 rm -rf "$TEST_TMPDIR"
265 if test -n "$GIT_EXIT_OK"
270 say_color error '%-6s' FATAL
271 echo " $test_subtest_name"
273 echo "Unexpected exit while executing $0. Exit code $code."
280 echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
287 say_color error '%-6s' FATAL
290 echo "Unexpected exit while executing $0."
295 # Note: TEST_TMPDIR *NOT* exported!
296 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
297 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
298 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
299 trap 'trap_exit' EXIT
300 trap 'trap_signal' HUP INT TERM
302 # Deliver a message with emacs and add it to the database
304 # Uses emacs to generate and deliver a message to the mail store.
305 # Accepts arbitrary extra emacs/elisp functions to modify the message
306 # before sending, which is useful to doing things like attaching files
307 # to the message and encrypting/signing.
308 emacs_deliver_message ()
313 # before we can send a message, we have to prepare the FCC maildir
314 mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
315 # eval'ing smtp-dummy --background will set smtp_dummy_pid
317 eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
318 test -n "$smtp_dummy_pid" || return 1
321 "(let ((message-send-mail-function 'message-smtpmail-send-it)
322 (mail-host-address \"example.com\")
323 (smtpmail-smtp-server \"localhost\")
324 (smtpmail-smtp-service \"25025\"))
327 (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
328 (message-goto-subject)
329 (insert \"${subject}\")
333 (notmuch-mua-send-and-exit))"
335 # In case message was sent properly, client waits for confirmation
336 # before exiting and resuming control here; therefore making sure
337 # that server exits by sending (KILL) signal to it is safe.
338 kill -9 $smtp_dummy_pid
339 notmuch new >/dev/null
342 # Pretend to deliver a message with emacs. Really save it to a file
343 # and add it to the database
345 # Uses emacs to generate and deliver a message to the mail store.
346 # Accepts arbitrary extra emacs/elisp functions to modify the message
347 # before sending, which is useful to doing things like attaching files
348 # to the message and encrypting/signing.
350 # If any GNU-style long-arguments (like --quiet or --decrypt=true) are
351 # at the head of the argument list, they are sent directly to "notmuch
352 # new" after message delivery
356 while [[ "$1" =~ ^-- ]]; do
357 nmn_args="$nmn_args $1"
363 # before we can send a message, we have to prepare the FCC maildir
364 mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
367 "(let ((message-send-mail-function (lambda () t))
368 (mail-host-address \"example.com\"))
371 (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
372 (message-goto-subject)
373 (insert \"${subject}\")
377 (notmuch-mua-send-and-exit))" || return 1
378 notmuch new $nmn_args >/dev/null
381 # Add an existing, fixed corpus of email to the database.
383 # $1 is the corpus dir under corpora to add, using "default" if unset.
385 # The default corpus is based on about 50 messages from early in the
386 # history of the notmuch mailing list, which allows for reliably
387 # testing commands that need to operate on a not-totally-trivial
388 # number of messages.
394 if [ -d $TEST_DIRECTORY/corpora.mail/$corpus ]; then
395 cp -a $TEST_DIRECTORY/corpora.mail/$corpus ${MAIL_DIR}
397 cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
398 notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
399 mkdir -p $TEST_DIRECTORY/corpora.mail
400 cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpora.mail/$corpus
404 test_begin_subtest ()
406 if [ -n "$inside_subtest" ]; then
407 exec 1>&6 2>&7 # Restore stdout and stderr
408 error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
410 test_subtest_name="$1"
412 # Redirect test output to the previously prepared file descriptors
413 # 3 and 4 (see below)
414 if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
419 # Pass test if two arguments match
421 # Note: Unlike all other test_expect_* functions, this function does
422 # not accept a test name. Instead, the caller should call
423 # test_begin_subtest before calling this function in order to set the
427 exec 1>&6 2>&7 # Restore stdout and stderr
428 if [ -z "$inside_subtest" ]; then
429 error "bug in the test script: test_expect_equal without test_begin_subtest"
433 error "bug in the test script: not 2 parameters to test_expect_equal"
437 if ! test_skip "$test_subtest_name"
439 if [ "$output" = "$expected" ]; then
442 testname=$this_test.$test_count
443 echo "$expected" > $testname.expected
444 echo "$output" > $testname.output
445 test_failure_ "$(diff -u $testname.expected $testname.output)"
450 # Like test_expect_equal, but takes two filenames.
451 test_expect_equal_file ()
453 exec 1>&6 2>&7 # Restore stdout and stderr
454 if [ -z "$inside_subtest" ]; then
455 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
459 error "bug in the test script: not 2 parameters to test_expect_equal_file"
463 if ! test_skip "$test_subtest_name"
465 if diff -q "$file1" "$file2" >/dev/null ; then
468 testname=$this_test.$test_count
469 basename1=`basename "$file1"`
470 basename2=`basename "$file2"`
471 cp "$file1" "$testname.$basename1"
472 cp "$file2" "$testname.$basename2"
473 test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
478 # Like test_expect_equal, but arguments are JSON expressions to be
479 # canonicalized before diff'ing. If an argument cannot be parsed, it
480 # is used unchanged so that there's something to diff against.
481 test_expect_equal_json () {
482 # The test suite forces LC_ALL=C, but this causes Python 3 to
483 # decode stdin as ASCII. We need to read JSON in UTF-8, so
484 # override Python's stdio encoding defaults.
485 local script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
486 output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
488 expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
491 test_expect_equal "$output" "$expected" "$@"
494 # Sort the top-level list of JSON data from stdin.
496 PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
497 "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
500 test_emacs_expect_t () {
502 error "bug in the test script: not 1 parameter to test_emacs_expect_t"
503 if [ -z "$inside_subtest" ]; then
504 error "bug in the test script: test_emacs_expect_t without test_begin_subtest"
508 if ! test_skip "$test_subtest_name"
510 test_emacs "(notmuch-test-run $1)" >/dev/null
512 # Restore state after the test.
513 exec 1>&6 2>&7 # Restore stdout and stderr
516 # Report success/failure.
522 test_failure_ "${result}"
525 # Restore state after the (non) test.
526 exec 1>&6 2>&7 # Restore stdout and stderr
533 notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
538 # this relies on the default format being batch-tag, otherwise some tests will break
539 notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
542 notmuch_drop_mail_headers ()
546 msg = email.message_from_file(sys.stdin)
547 for hdr in sys.argv[1:]: del msg[hdr]
548 print(msg.as_string(False))
552 notmuch_search_sanitize ()
554 perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
557 notmuch_search_files_sanitize ()
562 notmuch_dir_sanitize ()
564 sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
567 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
568 notmuch_show_sanitize ()
570 sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
572 notmuch_show_sanitize_all ()
575 -e 's| filename:.*| filename:XXXXX|' \
576 -e 's| id:[^ ]* | id:XXXXX |' | \
577 notmuch_date_sanitize
580 notmuch_json_show_sanitize ()
583 -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
584 -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
585 -e 's|"filename": "signature.asc",||g' \
586 -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
587 -e 's|"timestamp": 97.......|"timestamp": 42|g' \
588 -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
591 notmuch_emacs_error_sanitize ()
599 -e 's/^\[.*\]$/[XXX]/' \
600 -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
603 notmuch_date_sanitize ()
606 -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
609 notmuch_uuid_sanitize ()
611 sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
614 notmuch_built_with_sanitize ()
616 sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
619 notmuch_config_sanitize ()
621 notmuch_dir_sanitize | notmuch_built_with_sanitize
626 awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
629 # End of notmuch helper functions
631 # Use test_set_prereq to tell that a particular prerequisite is available.
633 # The prerequisite can later be checked for by using test_have_prereq.
635 # The single parameter is the prerequisite tag (a simple word, in all
636 # capital letters by convention).
639 satisfied="$satisfied$1 "
643 test_have_prereq () {
652 declare -A test_missing_external_prereq_
653 declare -A test_subtest_missing_external_prereq_
655 # declare prerequisite for the given external binary
656 test_declare_external_prereq () {
658 test "$#" = 2 && name=$2 || name="$binary(1)"
660 if ! hash $binary 2>/dev/null; then
661 test_missing_external_prereq_["${binary}"]=t
664 test_subtest_missing_external_prereq_[\"${name}\"]=t
670 # Explicitly require external prerequisite. Useful when binary is
671 # called indirectly (e.g. from emacs).
672 # Returns success if dependency is available, failure otherwise.
673 test_require_external_prereq () {
675 if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
676 # dependency is missing, call the replacement function to note it
683 # You are not expected to call test_ok_ and test_failure_ directly, use
684 # the text_expect_* functions instead.
687 if test "$test_subtest_known_broken_" = "t"; then
688 test_known_broken_ok_
691 test_success=$(($test_success + 1))
692 if test -n "$NOTMUCH_TEST_QUIET"; then
695 say_color pass "%-6s" "PASS"
696 echo " $test_subtest_name"
700 print_test_description
701 if test "$test_subtest_known_broken_" = "t"; then
702 test_known_broken_failure_ "$@"
705 test_failure=$(($test_failure + 1))
706 test_failure_message_ "FAIL" "$test_subtest_name" "$@"
707 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
711 test_failure_message_ () {
712 say_color error "%-6s" "$1"
715 if [ "$#" != "0" ]; then
716 echo "$@" | sed -e 's/^/ /'
718 if test "$verbose" != "t"; then cat test.output; fi
721 test_known_broken_ok_ () {
723 test_fixed=$(($test_fixed+1))
724 say_color pass "%-6s" "FIXED"
725 echo " $test_subtest_name"
728 test_known_broken_failure_ () {
730 test_broken=$(($test_broken+1))
731 if [ -z "$NOTMUCH_TEST_QUIET" ]; then
732 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
734 test_failure_message_ "BROKEN" "$test_subtest_name"
740 test "$debug" = "" || eval "$1"
745 if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
748 eval >&3 2>&4 "$test_cleanup"
753 test_count=$(($test_count+1))
755 for skp in $NOTMUCH_SKIP_TESTS
757 case $this_test.$test_count in
762 case $this_test_bare.$test_count in
770 test_report_skip_ "$@"
773 test_check_missing_external_prereqs_ "$@"
778 test_check_missing_external_prereqs_ () {
779 if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
780 say_color skip >&1 "missing prerequisites: "
781 echo ${!test_subtest_missing_external_prereq_[@]} >&1
782 test_report_skip_ "$@"
788 test_report_skip_ () {
790 say_color skip >&3 "skipping test:"
792 say_color skip "%-6s" "SKIP"
796 test_subtest_known_broken () {
797 test_subtest_known_broken_=t
800 test_expect_success () {
801 exec 1>&6 2>&7 # Restore stdout and stderr
802 if [ -z "$inside_subtest" ]; then
803 error "bug in the test script: test_expect_success without test_begin_subtest"
807 error "bug in the test script: not 1 parameters to test_expect_success"
809 if ! test_skip "$test_subtest_name"
813 # test_run_ may update missing external prerequisites
814 test_check_missing_external_prereqs_ "$@" ||
815 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
824 test_expect_code () {
825 exec 1>&6 2>&7 # Restore stdout and stderr
826 if [ -z "$inside_subtest" ]; then
827 error "bug in the test script: test_expect_code without test_begin_subtest"
831 error "bug in the test script: not 2 parameters to test_expect_code"
833 if ! test_skip "$test_subtest_name"
837 # test_run_ may update missing external prerequisites,
838 test_check_missing_external_prereqs_ "$@" ||
839 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
843 test_failure_ "exit code $eval_ret, expected $1" "$2"
848 # This is not among top-level (test_expect_success)
849 # but is a prefix that can be used in the test script, like:
851 # test_expect_success 'complain and die' '
853 # do something else &&
854 # test_must_fail git checkout ../outerspace
857 # Writing this as "! git checkout ../outerspace" is wrong, because
858 # the failure could be due to a segv. We want a controlled failure.
862 test $? -gt 0 -a $? -le 129 -o $? -gt 192
865 # test_cmp is a helper function to compare actual and expected output.
866 # You can use it like:
868 # test_expect_success 'foo works' '
869 # echo expected >expected &&
871 # test_cmp expected actual
874 # This could be written as either "cmp" or "diff -u", but:
875 # - cmp's output is not nearly as easy to read as diff -u
876 # - not all diff versions understand "-u"
882 # This function can be used to schedule some commands to be run
883 # unconditionally at the end of the test to restore sanity:
885 # test_expect_success 'test core.capslock' '
886 # git config core.capslock true &&
887 # test_when_finished "git config --unset core.capslock" &&
891 # That would be roughly equivalent to
893 # test_expect_success 'test core.capslock' '
894 # git config core.capslock true &&
896 # git config --unset core.capslock
899 # except that the greeting and config --unset must both succeed for
902 test_when_finished () {
904 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
909 test_results_dir="$TEST_DIRECTORY/test-results"
910 mkdir -p "$test_results_dir"
911 test_results_path="$test_results_dir/$this_test"
913 echo "total $test_count" >> $test_results_path
914 echo "success $test_success" >> $test_results_path
915 echo "fixed $test_fixed" >> $test_results_path
916 echo "broken $test_broken" >> $test_results_path
917 echo "failed $test_failure" >> $test_results_path
918 echo "" >> $test_results_path
920 [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
922 if [ "$test_failure" = "0" ]; then
923 if [ "$test_broken" = "0" ]; then
932 emacs_generate_script () {
933 # Construct a little test script here for the benefit of the user,
934 # (who can easily run "run_emacs" to get the same emacs environment
935 # for investigating any failures).
936 cat <<EOF >"$TMP_DIRECTORY/run_emacs"
939 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
941 # Here's what we are using here:
943 # --quick Use minimal customization. This implies --no-init-file,
944 # --no-site-file and (emacs 24) --no-site-lisp
946 # --directory Ensure that the local elisp sources are found
948 # --load Force loading of notmuch.el and test-lib.el
950 exec ${TEST_EMACS} --quick \
951 --directory "$NOTMUCH_SRCDIR/emacs" --load notmuch.el \
952 --directory "$NOTMUCH_SRCDIR/test" --load test-lib.el \
955 chmod a+x "$TMP_DIRECTORY/run_emacs"
959 # test dependencies beforehand to avoid the waiting loop below
960 missing_dependencies=
961 test_require_external_prereq dtach || missing_dependencies=1
962 test_require_external_prereq emacs || missing_dependencies=1
963 test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
964 test -z "$missing_dependencies" || return
966 if [ -z "$EMACS_SERVER" ]; then
967 emacs_tests="$NOTMUCH_SRCDIR/test/${this_test_bare}.el"
968 if [ -f "$emacs_tests" ]; then
969 load_emacs_tests="--eval '(load \"$emacs_tests\")'"
973 server_name="notmuch-test-suite-$$"
974 # start a detached session with an emacs server
975 # user's TERM (or 'vt100' in case user's TERM is known dumb
976 # or unknown) is given to dtach which assumes a minimally
977 # VT100-compatible terminal -- and emacs inherits that
978 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
979 sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
982 --eval '(setq server-name \"$server_name\")' \
983 --eval '(server-start)' \
984 --eval '(orphan-watchdog $$)'" || return
985 EMACS_SERVER="$server_name"
986 # wait until the emacs server is up
987 until test_emacs '()' >/dev/null 2>/dev/null; do
992 # Clear test-output output file. Most Emacs tests end with a
993 # call to (test-output). If the test code fails with an
994 # exception before this call, the output file won't get
995 # updated. Since we don't want to compare against an output
996 # file from another test, so start out with an empty file.
1000 ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $@)"
1004 # Note: if there is need to print debug information from python program,
1005 # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
1006 PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
1007 $NOTMUCH_PYTHON -B - > OUTPUT
1011 MAIL_DIR=$MAIL_DIR $NOTMUCH_RUBY -I $NOTMUCH_SRCDIR/bindings/ruby> OUTPUT
1015 exec_file="test${test_count}"
1016 test_file="${exec_file}.c"
1018 ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
1019 echo "== stdout ==" > OUTPUT.stdout
1020 echo "== stderr ==" > OUTPUT.stderr
1021 ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1022 notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr > OUTPUT
1026 # Creates a script that counts how much time it is executed and calls
1027 # notmuch. $notmuch_counter_command is set to the path to the
1028 # generated script. Use notmuch_counter_value() function to get the
1029 # current counter value.
1030 notmuch_counter_reset () {
1031 notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1032 if [ ! -x "$notmuch_counter_command" ]; then
1033 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1034 cat >"$notmuch_counter_command" <<EOF || return
1037 read count < "$notmuch_counter_state_path"
1038 echo \$((count + 1)) > "$notmuch_counter_state_path"
1042 chmod +x "$notmuch_counter_command" || return
1045 echo 0 > "$notmuch_counter_state_path"
1048 # Returns the current notmuch counter value.
1049 notmuch_counter_value () {
1050 if [ -r "$notmuch_counter_state_path" ]; then
1051 read count < "$notmuch_counter_state_path"
1058 test_reset_state_ () {
1059 test -z "$test_init_done_" && test_init_
1061 test_subtest_known_broken_=
1062 test_subtest_missing_external_prereq_=()
1065 # called once before the first subtest
1069 # skip all tests if there were external prerequisites missing during init
1070 test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1074 # Where to run the tests
1075 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
1077 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
1079 if [ "${NOTMUCH_GMIME_MAJOR}" = 3 ]; then
1080 test_subtest_broken_gmime_3 () {
1081 test_subtest_known_broken
1083 test_subtest_broken_gmime_2 () {
1087 test_subtest_broken_gmime_3 () {
1090 test_subtest_broken_gmime_2 () {
1091 test_subtest_known_broken
1095 emacs_generate_script
1098 # Use -P to resolve symlinks in our working directory so that the cwd
1099 # in subprocesses like git equals our $PWD (for pathname comparisons).
1100 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
1102 if test "$verbose" = "t"
1106 exec 4>test.output 3>&4
1109 for skp in $NOTMUCH_SKIP_TESTS
1112 for skp in $NOTMUCH_SKIP_TESTS
1114 case "$this_test" in
1119 case "$this_test_bare" in
1127 say_color skip >&3 "skipping test $this_test altogether"
1128 say_color skip "skip all tests in $this_test"
1133 # Provide an implementation of the 'yes' utility
1148 # Fix some commands on Windows
1151 # Windows has its own (incompatible) sort and find
1161 # git sees Windows-style pwd
1165 # no POSIX permissions
1166 # backslashes in pathspec are converted to '/'
1167 # exec does not inherit the PID
1170 test_set_prereq POSIXPERM
1171 test_set_prereq BSLASHPSPEC
1172 test_set_prereq EXECKEEPSPID
1176 test -z "$NO_PERL" && test_set_prereq PERL
1177 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1179 # test whether the filesystem supports symbolic links
1180 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1183 # convert variable from configure to more convenient form
1184 case "$NOTMUCH_DEFAULT_XAPIAN_BACKEND" in
1192 error "Unknown Xapian backend $NOTMUCH_DEFAULT_XAPIAN_BACKEND"
1194 # declare prerequisites for external binaries used in tests
1195 test_declare_external_prereq dtach
1196 test_declare_external_prereq emacs
1197 test_declare_external_prereq ${TEST_EMACSCLIENT}
1198 test_declare_external_prereq ${TEST_GDB}
1199 test_declare_external_prereq gpg
1200 test_declare_external_prereq openssl
1201 test_declare_external_prereq gpgsm
1202 test_declare_external_prereq ${NOTMUCH_PYTHON}